/*
	$Id: GroupManager.java 175 2006-04-23 16:08:10Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.util.LinkedList;
import java.util.List;
import org.w3c.dom.Element;

/**
   롼ץޥ͡Ǥ

   롼ץޥ͡ϤѥåΥ롼סʥ饹ޤϥ󥿥ե
   ˤޤ
*/
public class GroupManager {

    /** Υ롼פ֤̾ΰ */
    private Location location;

    /** Υ롼פ˽°빽¤ */
    private LinkedList<Compound> structs;

    /** Υ롼פ˽°붦 */
    private LinkedList<Compound> unions;

    /** Υ롼פ˽° */
    private LinkedList<Compound> enums;

    /** ̻ҥޥ͡ */
    private IDManager idManager;

    /**
       롼ץޥ͡ޤ

       @param packageName ѥå̾
       @param name 饹̾ޤϥ󥿥ե̾
    */
    public GroupManager(final String packageName, final String name) {
	location = new Location(packageName, name);
	structs = new LinkedList<Compound>();
	unions = new LinkedList<Compound>();
	enums = new LinkedList<Compound>();
	idManager = IDManager.getInstance();
    }

    /**
       Υ롼פ˽°뷿ޤ

       @param elem typedef
       @return 
    */
    public Typedef createTypedef(final Element elem) {
	Typedef m = new Typedef(elem);
	idManager.addKeyword(location, m.getName());
	return m;
    }

    /**
       Υ롼פ˽°ޥޤ

       @param elem define
       @return ޥ
    */
    public Macro createMacro(final Element elem) {
	Macro m = new Macro(elem);
	idManager.addKeyword(location, m.getKeyword());
	return m;
    }

    /**
       Υ롼פ˽°󷿤ޤ

       @param elem constant
       @return 󷿤
    */
    public Constant createConstant(final Element elem) {
	Constant m = new Constant(elem);
	idManager.addKeyword(location, m.getName());
	return m;
    }

    /**
       Υ롼פ˽°ؿޤ

       @param elem method
       @return ؿ
    */
    public Method createMethod(final Element elem) {
	Method m = new Method("@", elem);
	idManager.addKeyword(location, m.getName());
	return m;
    }

    /**
       Υ롼פ˽°륰Хѿޤ

       @param elem globalvariable
       @return Хѿ
    */
    public GlobalVariable createGlobalVariable(final Element elem) {
	GlobalVariable m = new GlobalVariable(elem);
	idManager.addKeyword(location, m.getName());
	return m;
    }

    /**
       Υ롼פ˽°빽¤Τޤ϶ΤΥФޤ

       @param parentName Ф°빽¤Τޤ϶Τ̾
       @param elem memberǡstructmemberǡunionmemberǡ
       enummemberǡޤmethod
       @return ¤Τޤ϶ΤΥ
    */
    public Member createMember(final String parentName, final Element elem) {
	if (elem.getNodeName().equals("structmember")) {
	    StructUnionMember m = new StructUnionMember(this, parentName,
							"struct", elem);
	    structs.add(m);
	    idManager.addKeyword(location, m.getDescType());
	    return m;
	} else if (elem.getNodeName().equals("unionmember")) {
	    StructUnionMember m = new StructUnionMember(this, parentName,
							"union", elem);
	    unions.add(m);
	    idManager.addKeyword(location, m.getDescType());
	    return m;
	} else if (elem.getNodeName().equals("enummember")) {
	    EnumMember m = new EnumMember(this, parentName, elem);
	    enums.add(m);
	    idManager.addKeyword(location, m.getDescType());
	    return m;
	} else if (elem.getNodeName().equals("method")) {
	    Member m = new MethodMember(parentName, elem);
	    idManager.addKeyword(location, parentName + "." + m.getName());
	    return m;
	} else {
	    Member m = new Member(parentName, elem);
	    idManager.addKeyword(location, parentName + "." + m.getName());
	    return m;
	}
    }

    /**
       Ǥ°ޤ

       ŪˤϤ°ƤѴ֤褦ˤޤ

       @param elem 
       @param s °̾
       @return °
    */
    private String getReplacedAttribute(final Element elem, final String s) {
	String v = elem.getAttribute(s);
	/*
	if (s.equals("@")) {
	    s = location.getPrefix();
	}
	*/
	return v;
    }

    /**
       Υ롼פ˽°빽¤Τޤ

       @param elem struct
       @return ¤
    */
    public StructUnion createStruct(final Element elem) {
	String name = getReplacedAttribute(elem, "name");
	String as = getReplacedAttribute(elem, "alias");

	StructUnion m = new StructUnion(this, "struct", elem, name, as);
	structs.add(m);
	idManager.addKeyword(location, m.getDescType());
	idManager.addKeyword(location, as);
	return m;
    }

    /**
       Υ롼פ˽°붦Τޤ

       @param elem union
       @return 
    */
    public StructUnion createUnion(final Element elem) {
	String name = getReplacedAttribute(elem, "name");
	String as = getReplacedAttribute(elem, "alias");

	StructUnion m = new StructUnion(this, "union", elem, name, as);
	unions.add(m);
	idManager.addKeyword(location, m.getDescType());
	idManager.addKeyword(location, as);
	return m;
    }

    /**
       Υ롼פ˽°󷿤ޤ

       @param elem enum
       @return 
    */
    public Enum createEnum(final Element elem) {
	String name = elem.getAttribute("name");
	String as = elem.getAttribute("alias");

	Enum m = new Enum(this, elem, name, as);
	enums.add(m);
	idManager.addKeyword(location, m.getDescType());
	idManager.addKeyword(location, as);
	return m;
    }

    /**
       Υ롼פ˽°빽¤ΤΥꥹȤޤ

       @return ¤ΤΥꥹ
    */
    public List<Compound> getAllStructs() {
	return structs;
    }

    /**
       Υ롼פ˽°붦ΤΥꥹȤޤ

       @return ΤΥꥹ
    */
    public List<Compound> getAllUnions() {
	return unions;
    }

    /**
       Υ롼פ˽°󷿤ΥꥹȤޤ

       @return 󷿤Υꥹ
    */
    public List<Compound> getAllEnums() {
	return enums;
    }
}
