/*
	$Id: Macro.java 175 2006-04-23 16:08:10Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.io.PrintWriter;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;

/**
   ޥǤ
*/
public class Macro {

    /** ޥ̾ */
    private String name;

    /** ޥμ̻ */
    private String keyword;

    /** macroǤ */
    private String macro;

    /** descǤ */
    private Description desc;

    /**
       ޥޤ

       @param elem define
    */
    public Macro(final Element elem) {
	name = elem.getAttribute("name");

	ChildrenFilter c = new ChildrenFilter(elem);
	macro = getMacro(c.getDirectChildrenByTagName("macro"));
	desc = new Description(c.getDirectChildrenByTagName("desc"));

	int k = name.indexOf('(');
	keyword = ((k == -1) ? name : name.substring(0, k).trim());
    }

    /**
       macroǤƤޤ

       @param nodes macroǤΥΡɥꥹ
       @return macroǤ
    */
    private String getMacro(final NodeList nodes) {
        if (nodes.getLength() == 0) {
            return "";
	}
        Node node = (Element) nodes.item(0);
	String s = "";
        NodeList children = node.getChildNodes();
        for (int i = 0; i < children.getLength(); ++i) {
            Node child = children.item(i);
            if (child.getNodeType() == Node.TEXT_NODE) {
                s += child.getNodeValue();
            }
	}
	return s;
    }

    /**
       ޥ̾ޤ

       @return ޥ̾
    */
    public String getName() {
	return name;
    }

    /**
       ޥμ̻Ҥޤ

       @return ޥμ̻
    */
    public String getKeyword() {
	return keyword;
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	String s = macro.trim();
	int k;

	if (s.indexOf('\n') == -1) {
	    wr.println(""
+ "#define " + name + " " + macro);
	    return;
	}

	wr.print("#define " + name + " \\\n\t");
	while ((k = s.indexOf('\n')) >= 0) {
	    wr.print(s.substring(0, k) + " \\\n\t");
	    s = s.substring(k + 1);
	}
	wr.println(s);
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	wr.println(""
+ "<tr>\n"
+ "  <td><a href=\"#" + keyword + "\"><b>" + name + "</b></a><br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	wr.print(""
+ "<p><a name=\"" + keyword + "\"></a>"
+ "<font size=\"+1\"><b>" + name + "</b></font></p>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n"
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	wr.println("\\Sid{" + Tex.safe(name) + "}");
	wr.println(desc.getTexText());
    }
}
